﻿using Dapper;
using QuizApplication.Models;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.Linq;

namespace QuizApplication.DataHandler
{
    class SqlDataHandler
    {
        string connectionString { get; set; }

        public SqlDataHandler()
        {
            connectionString = ConfigurationManager.ConnectionStrings["QuizDB"].ConnectionString; // set Connection String in App.config
        }//

        //Add New User
        public int AddNewUser(UserModel userModel)
        {
            using (IDbConnection connection = new SqlConnection(connectionString))
            {
                var userData = connection.QueryFirstOrDefault<UserModel>($"SELECT *from dbo.Users where email='{userModel.email}'");
                if (userData != null)
                    throw new ArgumentException("Email already exist");

                var status = connection.Execute($"INSERT into Users(email, password) VALUES('{userModel.email}','{userModel.password}')");
                return status;
            }
        }


        //Add New Admin
        public int AddNewAdmin(UserModel userModel)
        {
            using (IDbConnection connection = new SqlConnection(connectionString))
            {
                var userData = connection.QueryFirstOrDefault<UserModel>($"SELECT *from dbo.Admins where email='{userModel.email}'");
                if (userData != null)
                    throw new ArgumentException("Email already exist");

                var status = connection.Execute($"INSERT into Admins(email, password) VALUES('{userModel.email}','{userModel.password}')");
                return status;
            }
        }

        //Check User
        public bool VerifyUser(UserModel userModel)
        {
            using (IDbConnection connection = new SqlConnection(connectionString))
            {
                var status = connection.QueryFirstOrDefault<UserModel>($"SELECT *from dbo.Users where email='{userModel.email}' AND password='{userModel.password}'");
                if (status == null)
                    return false;
                else
                    return true;
            }
        }//

        //Check Admin
        public bool VerifyAdmin(UserModel userModel)
        {
            using (IDbConnection connection = new SqlConnection(connectionString))
            {
                var status = connection.QueryFirstOrDefault<UserModel>($"SELECT *from dbo.Admins where email='{userModel.email}' AND password='{userModel.password}'");
                if (status == null)
                    return false;
                else
                    return true;
            }
        }//


        //Add New Question
        public int AddNewQuestion(DbQuestionsModel dbQuestionsModel)
        {
            using (IDbConnection connection = new SqlConnection(connectionString))
            {
                var status = connection.Execute(@$"INSERT into Questions(question,answer1,answer2,answer3,answer4,correctAns) 
                                    VALUES('{dbQuestionsModel.question}','{dbQuestionsModel.answer1}','{dbQuestionsModel.answer2}',
                                    '{dbQuestionsModel.answer3}','{dbQuestionsModel.answer4}','{dbQuestionsModel.correctAns}')");
                return status;
            }
        }//


        //Get Questions
        public List<DbQuestionsModel> GetQuestions()
        {
            using (IDbConnection connection = new SqlConnection(connectionString))
            {
                var questions = connection.Query<DbQuestionsModel>("select * from Questions");
                return questions.ToList<DbQuestionsModel>();
            }
        }//

        //Update Questions
        public int UpdateQuestions(DbQuestionsModel dbQuestionsModel)
        {
            using (IDbConnection connection = new SqlConnection(connectionString))
            {
                var status = connection.Execute(@$"update Questions set question = '{dbQuestionsModel.question}', answer1 = '{dbQuestionsModel.answer1}',
                                            answer2 = '{dbQuestionsModel.answer2}',answer3 = '{dbQuestionsModel.answer3}',answer4 = '{dbQuestionsModel.answer4}',
                                            correctAns = '{dbQuestionsModel.correctAns}' where id = {dbQuestionsModel.id} ");
                return status;
            }
        }

        //Update Questions
        public int DeleteQuestions(DbQuestionsModel dbQuestionsModel)
        {
            using (IDbConnection connection = new SqlConnection(connectionString))
            {
                var status = connection.Execute(@$"delete from Questions where id={dbQuestionsModel.id}");
                return status;
            }
        }

    }
}
