﻿using Caliburn.Micro;
using QuizApplication.DataHandler;
using QuizApplication.Models;
using System.Windows;

namespace QuizApplication.ViewModels
{
    class AddQuestionViewModel : Screen
    {
        private string _question { get; set; }
        public string Question { get => _question; set { _question = value; NotifyOfPropertyChange(); } }
        private string _answer1 { get; set; }
        public string Answer1 { get => _answer1; set { _answer1 = value; NotifyOfPropertyChange(); } }
        private string _answer2 { get; set; }
        public string Answer2 { get => _answer2; set { _answer2 = value; NotifyOfPropertyChange(); } }
        private string _answer3 { get; set; }
        public string Answer3 { get => _answer3; set { _answer3 = value; NotifyOfPropertyChange(); } }
        private string _answer4 { get; set; }
        public string Answer4 { get => _answer4; set { _answer4 = value; NotifyOfPropertyChange(); } }
        private bool _iscorrect1 { get; set; }
        public bool Iscorrect1 { get => _iscorrect1; set { _iscorrect1 = value; if (_iscorrect1) CorrectAnswer = "a"; NotifyOfPropertyChange(); } }
        private bool _iscorrect2 { get; set; }
        public bool Iscorrect2 { get => _iscorrect2; set { _iscorrect2 = value; if (_iscorrect2) CorrectAnswer = "b"; NotifyOfPropertyChange(); } }
        private bool _iscorrect3 { get; set; }
        public bool Iscorrect3 { get => _iscorrect3; set { _iscorrect3 = value; if (_iscorrect3) CorrectAnswer = "c"; NotifyOfPropertyChange(); } }
        private bool _iscorrect4 { get; set; }
        public bool Iscorrect4 { get => _iscorrect4; set { _iscorrect4 = value; if (_iscorrect4) CorrectAnswer = "d"; NotifyOfPropertyChange(); } }
        private string _correctAnswer { get; set; }
        public string CorrectAnswer { get => _correctAnswer; set { _correctAnswer = value; NotifyOfPropertyChange(); } }

        private bool isUpdate = false;
        private int id = -1;

        public AddQuestionViewModel()
        {
            Iscorrect1 = true;
        }

        public AddQuestionViewModel(DbQuestionsModel dbQuestionsModel)
        {
            isUpdate = true;
            id = dbQuestionsModel.id;
            Question = dbQuestionsModel.question;
            Answer1 = dbQuestionsModel.answer1;
            Answer2 = dbQuestionsModel.answer2;
            Answer3 = dbQuestionsModel.answer3;
            Answer4 = dbQuestionsModel.answer4;

            if (dbQuestionsModel.correctAns == "a")
                Iscorrect1 = true;
            else if (dbQuestionsModel.correctAns == "b")
                Iscorrect2 = true;
            else if (dbQuestionsModel.correctAns == "c")
                Iscorrect3 = true;
            else
                Iscorrect4 = true;
        }

        public void SaveQuestionCommand()
        {
            if (string.IsNullOrEmpty(Question) || string.IsNullOrEmpty(Answer1) ||
                string.IsNullOrEmpty(Answer2) || string.IsNullOrEmpty(Answer3) || string.IsNullOrEmpty(Answer4))
            {
                MessageBox.Show("some fields empty");
                return;
            }

            SqlDataHandler sqlDataHandler = new SqlDataHandler();
            DbQuestionsModel dbQuestionsModel = new DbQuestionsModel
            {
                question = Question,
                answer1 = Answer1,
                answer2 = Answer2,
                answer3 = Answer3,
                answer4 = Answer4,
                correctAns = CorrectAnswer,
            };

            if (!isUpdate)
            {
                var status = sqlDataHandler.AddNewQuestion(dbQuestionsModel);

                if (status > 0)
                {
                    MessageBox.Show("new question added");
                    clearFields();
                }
                else
                    MessageBox.Show("error occured");
            }

            else
            {
                dbQuestionsModel.id = id;
                var status = sqlDataHandler.UpdateQuestions(dbQuestionsModel);

                if (status > 0)
                    MessageBox.Show("question updated");
                else
                    MessageBox.Show("error occured");
            }

        }//

        private void clearFields()
        {
            Question = string.Empty;
            Answer1 = string.Empty;
            Answer2 = string.Empty;
            Answer3 = string.Empty;
            Answer4 = string.Empty;
            Iscorrect1 = true;
        }
    }
}
