﻿using Caliburn.Micro;
using QuizApplication.DataHandler;
using QuizApplication.Helpers;
using System.Windows;
using System.Windows.Controls;

namespace QuizApplication.ViewModels
{
    class AdminLoginViewModel : Screen
    {
        private string _email { get; set; }
        public string Email { get => _email; set { _email = value; NotifyOfPropertyChange(); } }

        private string Password = string.Empty;
        public AdminLoginViewModel()
        {

        }
        public void OnPasswordChanged(PasswordBox source)
        {
            Password = source.Password;
        }

        public void SignInCommand()
        {
            if (string.IsNullOrEmpty(Password) || string.IsNullOrEmpty(Email))
            {
                MessageBox.Show("Fields Empty");
                return;
            }

            var sqlDataHandler = new SqlDataHandler();
            var status = sqlDataHandler.VerifyAdmin(new Models.UserModel { email = Email, password = Md5Hash.MD5Hash(Password) });

            if (status)
            {
                var conductor = this.Parent as IConductor;
                conductor.ActivateItemAsync(new AdminMenuViewModel());
            }
            else
                MessageBox.Show("admin not found");
        }

    }
}
