﻿using Caliburn.Micro;
using QuizApplication.DataHandler;
using QuizApplication.Models;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Windows;

namespace QuizApplication.ViewModels
{
    class EditQuestionViewModel : Screen
    {
        private ObservableCollection<DbQuestionsModel> _questions { get; set; }
        public ObservableCollection<DbQuestionsModel> Questions { get => _questions; set { _questions = value; NotifyOfPropertyChange(); } }

        private DbQuestionsModel _selectedValue { get; set; }
        public DbQuestionsModel SelectedValue { get => _selectedValue; set { _selectedValue = value; NotifyOfPropertyChange(); } }

        SqlDataHandler sqlDataHandler;
        public EditQuestionViewModel()
        {
            sqlDataHandler = new SqlDataHandler();
            Questions = new ObservableCollection<DbQuestionsModel>(sqlDataHandler.GetQuestions());
        }

        public void EditCommand()
        {
            if (SelectedValue == null)
            {
                MessageBox.Show("no value selected");
                return;
            }
            var conductor = this.Parent as IConductor;
            conductor.ActivateItemAsync(new AddQuestionViewModel(SelectedValue));
        }//

        public void DeleteCommand()
        {
            if (SelectedValue == null)
            {
                MessageBox.Show("no value selected");
                return;
            }
            var status = sqlDataHandler.DeleteQuestions(SelectedValue);
            if (status > 0)
            {
                MessageBox.Show("question deleted");
                Questions.Remove(SelectedValue);
            }
            else
                MessageBox.Show("error occured");

        }//

    }
}
