﻿using Caliburn.Micro;
using QuizApplication.DataHandler;
using QuizApplication.Helpers;
using System.Windows;
using System.Windows.Controls;

namespace QuizApplication.ViewModels
{
    class StartViewModel : Screen
    {
        private string _email { get; set; }
        public string Email { get => _email; set { _email = value; NotifyOfPropertyChange(); } }

        private string Password = string.Empty;

        public StartViewModel()
        {

        }
        public void SignUpCommand()
        {
            var conductor = this.Parent as IConductor;
            conductor.ActivateItemAsync(new UserRegViewModel());
        }

        public void AdminCommand()
        {
            var conductor = this.Parent as IConductor;
            conductor.ActivateItemAsync(new AdminLoginViewModel());
        }

        public void OnPasswordChanged(PasswordBox source)
        {
            Password = source.Password;
        }

        public void SignInCommand()
        {
            if (string.IsNullOrEmpty(Password) || string.IsNullOrEmpty(Email))
            {
                MessageBox.Show("Fields Empty");
                return;
            }

            var sqlDataHandler = new SqlDataHandler();
            var status = sqlDataHandler.VerifyUser(new Models.UserModel { email = Email, password = Md5Hash.MD5Hash(Password) });

            if (status)
            {
                var conductor = this.Parent as IConductor;
                conductor.ActivateItemAsync(new QuizViewModel());
            }
            else
                MessageBox.Show("user not found");
        }
    }
}
