﻿using Caliburn.Micro;
using QuizApplication.DataHandler;
using QuizApplication.Helpers;
using System;
using System.Windows;
using System.Windows.Controls;

namespace QuizApplication.ViewModels
{
    class UserRegViewModel : Screen
    {
        private string _email { get; set; }
        public string Email { get => _email; set { _email = value; NotifyOfPropertyChange(); } }

        private string Password = string.Empty;
        public UserRegViewModel()
        {

        }

        public void OnPasswordChanged(PasswordBox source)
        {
            Password = source.Password;
        }

        public void SignUpCommand()
        {
            if (string.IsNullOrEmpty(Password) || string.IsNullOrEmpty(Email))
            {
                MessageBox.Show("Fields Empty");
                return;
            }

            SqlDataHandler sqlDataHandler = new SqlDataHandler();
            try
            {
                var status = sqlDataHandler.AddNewUser(new Models.UserModel { email = Email, password = Md5Hash.MD5Hash(Password) });
                if (status > 0)
                {
                    MessageBox.Show("signup successful");
                    var conductor = this.Parent as IConductor;
                    conductor.ActivateItemAsync(new StartViewModel());
                }
            }
            catch (ArgumentException err) { MessageBox.Show(err.Message); };
        }

    }//
}
